找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1017|回复: 0

[他山之石] Entity Name of an Xref SubEntity From its Handle

[复制链接]

已领礼包: 1268个

财富等级: 财源广进

发表于 2013-7-13 17:23:24 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Entity Name of an Xref SubEntity From its Handle                         By Balaji Ramamoorthy
You can't access an xref'd sub-entity by passing its handle.  There could be a conflict with an object in the drawing which already has that handle assigned.  Instead it is necessary to check each block (after verifying that it is an xref) to see if one of its sub-entities' handle matches the handle argument which you passed to the lisp function.  The following examples prompt the user to type in a handle at the command-line, although it could just as easily have been passed in from another program:
;;;This example examines each xref in the blocks collection
;;;for a sub-entity whose handle matches the argument.

;;;Function (Get_XREF_SubEn)
(defun Get_XREF_SubEnt (sHandleID docCurrent / colBlocks isFound objBlk objSub xrDb)
   ;;get the blocks collection
   (setq colBlocks (vla-get-blocks docCurrent))
   (vlax-for objBlk colBlocks
      ;;Is the block an xref?
      (if (and
             (= (vlax-get-property objBlk 'IsXref) :vlax-true)
             (not isFound)
          ) ;and
         (vlax-for objSub objBlk
            ;;Does the sub-entity handle match the
            ;;handle passed to the function?
            (if (and
                   (= (vlax-get-property objSub 'Handle) sHandleID)
                   (not result)
                ) ;and
               ;;Then get the xref database
               (setq isFound T
                     xrDb (vlax-get-property objBlk 'XRefDatabase)
                     ;;Get the vla-object# of the sub-entity
                     result (vlax-invoke-method xrDb 'HandleToObject sHandleID)
               ) ;setq
            )
            (vlax-release-object objSub)
         ) ;vlax-for
      ) ;if
      (vlax-release-object objBlk)
   ) ;vlax-for
   (vlax-release-object colBlocks)

   ;;return value to calling function
   result
) ;Get_XREF_SubEnt

;;;Calling function
(defun c:Find_Subents ( / appAcad docActive sHandle objSubEnt result)
   (vl-load-com) ;load ActiveX
   (setq appAcad (vlax-get-acad-object)
         docActive (vla-get-ActiveDocument appAcad)
         sHandle (strcase (getstring "\Enter a handle: "))
   ) ;setq
   ;;call the function
   (setq objSubEnt(Get_XREF_SubEnt sHandle docActive))
   ;;display the result
   (if (/= objSubEnt nil)
   (alert
      (strcat "Handle \"" sHandle "\" = AutoCAD Object: "
              (vlax-get-property objSubEnt 'ObjectName)
      ) ;strcat
   ) ;alert
   )
   ;;release objects from memory
   (vlax-release-object docActive)
   (vlax-release-object appAcad)
) ;c:Find_Subents



评分

参与人数 1D豆 +5 收起 理由
xshrimp + 5

查看全部评分

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-9 23:35 , Processed in 0.357977 second(s), 33 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表